<?php

namespace LakeDrops\DrupalEnvironment;

use Composer\Script\Event;
use Composer\Script\ScriptEvents;
use LakeDrops\Component\Composer\BasePlugin;

/**
 * Composer plugin for handling drupal scaffold.
 */
class Plugin extends BasePlugin {

  /**
   * {@inheritdoc}
   */
  public function getHandlerClass(): string {
    return Handler::class;
  }

  /**
   * {@inheritdoc}
   */
  public function getCapabilities(): array {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents(): array {
    return [
      ScriptEvents::POST_CREATE_PROJECT_CMD => ['prepareProject', 1],
      ScriptEvents::POST_INSTALL_CMD => ['prepareProject', 1],
    ];
  }

  /**
   * Post update project event callback.
   *
   * @param \Composer\Script\Event $event
   *   The event that triggered the plugin.
   */
  public function prepareProject(Event $event) {
    /** @var Handler $handler */
    $handler = $this->handler;
    $handler
      ->setEvent($event)
      ->setupLakeDropsProject();
  }

}
